#!/bin/bash
#Automatically Created by buildpkg 1.4.0
#Maintainer: fushark <fushark-AT-yahoo-DOT-com>
#url: http://childsplay.sf.net

######Begin Redundant Code######################################
check_for_root() {
	if [ "$UID" != "0" ]; then
		echo "You need to be root"
		exit 1
	fi
}

clean_dirs () {
        for COMPLETED in src pkg; do
                if [ -e $COMPLETED ]; then
                        rm -rf $COMPLETED
                fi
        done
}

clean_old_builds () {
	for COMPLETED in $package.{tgz,md5,dep}; do
		if [ "$KEEPDEPFILE" = "1" ] && [ $COMPLETED = $package.dep ]; then
			continue
		elif [ -e $COMPLETED ]; then
			rm -rf $COMPLETED
		fi
	done
	clean_dirs
}

set_pre_permissions() {
	cd $startdir/src
	find . -perm 664 -exec chmod 644 {} \;
	find . -perm 600 -exec chmod 644 {} \;
	find . -perm 444 -exec chmod 644 {} \;
	find . -perm 400 -exec chmod 644 {} \;
	find . -perm 440 -exec chmod 644 {} \;
	find . -perm 777 -exec chmod 755 {} \;
	find . -perm 775 -exec chmod 755 {} \;
	find . -perm 511 -exec chmod 755 {} \;
	find . -perm 711 -exec chmod 755 {} \;
	find . -perm 555 -exec chmod 755 {} \;
}


check_for_menu_compliance() {
	if [ -d "$startdir/pkg/usr/share/applications" ]; then
		cd $startdir/pkg/usr/share/applications
		for desktop in *.desktop; do
			Icon=$(grep -e "^Icon=" $desktop | sed 's/Icon=//')
			if [[ "$Icon" ]]; then
				if [ ! "$Icon" == "${Icon%.*}" ]; then
					sed '/Icon/s/\..*$//' -i $desktop
					Icon=$(grep -e "^Icon=" $desktop | sed 's/Icon=//')
				fi
				if [ -d "$startdir/pkg/usr/share/pixmaps" ]; then
					cd $startdir/pkg/usr/share/pixmaps
					for pixmaps in *; do
						[ -d $pixmaps ] && continue
						[ ! "${pixmaps##*.}" == "png" -a ! "${pixmaps##*.}" == "svg" ] && continue
				 		if [ "${pixmaps%.*}" == "$Icon" ]; then
				 			DIR=$(file $pixmaps | awk -F, '{print $2}' | sed 's/ //g')
							[ o"$DIR" == "o" ] && DIR="scalable"
							mkdir -p $startdir/pkg/usr/share/icons/hicolor/$DIR/apps
							mv $pixmaps $startdir/pkg/usr/share/icons/hicolor/$DIR/apps
							if [[ ! "$(ls $startdir/pkg/usr/share/pixmaps)" ]]; then
								rm -rf $startdir/pkg/usr/share/pixmaps
							fi
						fi
					done
				fi
				if [ -d "$startdir/pkg/usr/share/icons" ]; then
					cd $startdir/pkg/usr/share/icons
					for icons in *; do
				 		if [ "${icons%.*}" == "$Icon" ]; then
							[ ! "${pixmaps##*.}" == "png" -a ! "${pixmaps##*.}" == "svg" ] && continue
				 			DIR=$(file $icons | awk -F, '{print $2}' | sed 's/ //g')
							[ o"$DIR" == "o" ] && DIR="scalable"
							mkdir -p $startdir/pkg/usr/share/icons/hicolor/$DIR/apps
							mv $icons $startdir/pkg/usr/share/icons/hicolor/$DIR/apps
						fi
					done
				fi
			fi
		done
	fi
}


gzip_man_and_info_pages() {
	for DOCS in man info; do
		if [ -d "$startdir/pkg/usr/share/$DOCS" ]; then
			mv $startdir/pkg/usr/share/$DOCS $startdir/pkg/usr/$DOCS
			if [[ ! "$(ls $startdir/pkg/usr/share)" ]]; then
				rm -rf $startdir/pkg/usr/share
			fi
		fi
		if [ -d "$startdir/pkg/usr/$DOCS" ]; then
			# I've never seen symlinks in info pages....
			if [ "$DOCS" == "man" ]; then
				(cd $startdir/pkg/usr/$DOCS
				for manpagedir in $(find . -type d -name "man*" 2> /dev/null) ; do
					( cd $manpagedir
					for eachpage in $( find . -type l -maxdepth 1 2> /dev/null) ; do
						ln -s $( readlink $eachpage ).gz $eachpage.gz
						rm $eachpage
					done )
				done)
			fi
			find $startdir/pkg/usr/$DOCS -type f -exec gzip -9 '{}' \;
		fi
	done
}

set_post_permissions() {
	for DIRS in usr/share/icons usr/doc; do
		if [ -d "$startdir/pkg/$DIRS" ]; then
			if [ "$DIRS" == "usr/doc" ]; then
				find $startdir/pkg/$DIRS -type f -exec chmod 644 {} \;
				find $startdir/pkg/$DIRS -type d -exec chmod 755 {} \;
			fi
		fi
		[ -d $startdir/pkg/$DIRS ] && chown root:root -R $startdir/pkg/$DIRS
	done
	[ -d $startdir/pkg/usr/bin ] && find $startdir/pkg/usr/bin -user root -group bin -exec chown root:root {} \;
}

copy_build_script() {
	mkdir -p $startdir/pkg/usr/src/$pkgname-$pkgver/
	cp $startdir/build-$pkgname.sh $startdir/pkg/usr/src/$pkgname-$pkgver/build-$pkgname.sh
	[ -f $startdir/ZENBUILD ] && cp $startdir/ZENBUILD $startdir/pkg/usr/src/$pkgname-$pkgver/ZENBUILD
}

create_package() {
	cd $startdir/pkg
	/sbin/makepkg -l y -c n $startdir/$package.tgz
	cd $startdir
	md5sum $package.tgz > $startdir/$package.md5
}

strip_binaries() {
	cd $startdir/pkg
	find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | \
	xargs strip --strip-unneeded 2> /dev/null
	find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | \
	xargs strip --strip-unneeded 2> /dev/null
}
#########End Redundant Code#####################################
#########Begin Non Redundant Code##############################

prepare_directory() {
	mkdir $startdir/src
	mkdir -p $startdir/pkg/usr/src/$pkgname-$pkgver
	for SOURCES in ${source[@]}; do
		protocol=$(echo $SOURCES | sed 's|:.*||')
		if [ ! -f "$(basename $SOURCES)" ]; then
			if [ "$protocol" = "http" -o "$protocol" = "https" -o "$protocol" = "ftp" ]; then
				echo -e "\nDownloading $(basename $SOURCES)\n"
				wget $SOURCES
				if [ ! "$?" == "0" ]; then
					echo "Download failed"
					exit 2
				fi 
			else
				echo "$SOURCES does not appear to be a url nor is it in the directory"
				exit 2
			fi
		fi
		cp -R $(basename $SOURCES) $startdir/src
		if ! [ "$protocol" = "http" -o "$protocol" = "https" -o "$protocol" = "ftp" ]; then
			cp -R $startdir/$(basename $SOURCES) $startdir/pkg/usr/src/$pkgname-$pkgver/
		fi
		if [ "${SOURCES##*.}" == "desktop" ]; then
			[[ "$(grep -e "^Categories=[a-zA-Z]*;" $(basename $SOURCES))" ]] && install -D $startdir/$(basename $SOURCES) /home/Depository/packages/Childsplay/base/pkg/usr/share/applications/$(basename $SOURCES)
		fi
	done
}

extract_source() {
	cd $startdir/src
	if [[ "$(ls $startdir/src)" ]]; then	
		for FILES in ${source[@]}; do
			FILES="$(basename $FILES)"
			file_type=$(file -biz "$FILES")
			unset cmd
			case "$file_type" in
				*application/x-tar*)
					cmd="tar -xf" ;;
				*application/x-zip*)
					cmd="unzip" ;;
				*application/x-gzip*)
					cmd="gunzip -d -f" ;;
				*application/x-bzip*)
					cmd="bunzip2 -f" ;;
			esac
			if [ "$cmd" != "" ]; then
				echo "$cmd $FILES"
	        	        $cmd $FILES
			fi
		done
	elif [ ! "$source" ]; then
		echo -n "" # lame fix
	else
		echo "no files in the src directory $startdir/src"
		exit 2
	fi
}

build() {
#create the needed directories
cd $startdir/pkg
mkdir -p var/games usr/bin usr/share/locale usr/lib/games/childsplay/lib usr/man/man6 usr/games usr/share/doc/childsplay usr/share/childsplay/Data/icons  usr/share/locale usr/share/assetml/childsplay usr/share/applications usr/share/childsplay/lib

#BASE PROGRAM INSTALLATION
#Begin Copying files
cd $startdir/src/$pkgname-$pkgver
CWD=`pwd`
#Copy libraries
for DIR in `ls $CWD/lib`
do 
    if [ -d $CWD/lib/$DIR ]
	 then cp -rf $CWD/lib/$DIR $startdir/pkg/usr/share/childsplay/lib/
	 else cp -f $CWD/lib/$DIR $startdir/pkg/usr/lib/games/childsplay/lib
    fi
done

cp -f $CWD/*.py $startdir/pkg/usr/lib/games/childsplay

#Copy misc. data files
for FILE in `ls $CWD/Data`
do 
    if [ -f $CWD/Data/$FILE ]
	 then cp -f $CWD/Data/$FILE $startdir/pkg//usr/share/childsplay/Data
    fi
done

cp -rf $CWD/Data/icons $startdir/pkg//usr/share/childsplay/Data
cp -f $CWD/Data/childsplay.score $startdir/pkg/var/games
chmod 0666 $startdir/pkg/var/games/childsplay.score
## As we are on *nix we must move the score file and replace it with a symlink 
mv -f $startdir/pkg/usr/share/childsplay/Data/childsplay.score $startdir/pkg/usr/share/childsplay/Data/childsplay.score.org

#symlinking to childsplay.score should be done in doinst.sh

#Copy assetml files
cp -rf $CWD/assetml/* $startdir/pkg/usr/share/assetml

#Copy locale files
cp -rf $CWD/locale/* $startdir/pkg/usr/share/locale

#Copy manpage
cp -f $CWD/man/* $startdir/pkg/usr/man/man6

#Copy docs
cp -rf $CWD/doc/* $startdir/pkg/usr/share/doc/childsplay

#Copy executable and setting permissions.
cp -f $CWD/childsplay.sh $startdir/pkg/usr/games/childsplay
cp -f $CWD/childsplay.sh $startdir/pkg/usr/bin/childsplay
chmod +x $startdir/pkg/usr/games/childsplay
chmod +x $startdir/pkg/usr/bin/childsplay

chmod +x $startdir/pkg/usr/lib/games/childsplay/childsplay.py
chmod +x $startdir/pkg/usr/lib/games/childsplay/letters-trans.py

#create BASEPATH.py
cat << "EOF" >$startdir/pkg//usr/lib/games/childsplay/BASEPATH.py
## Automated file please do not edit
BASEPATH="/usr"
EXECDIR="/usr/bin"
LOCALEDIR="/usr/share/locale"
ASSETMLDIR="/usr/share/assetml"
SCOREDIR="/var/games"
SCOREFILE="/var/games/childsplay.score"
DOCDIR="/usr/share/doc/childsplay"
MANDIR="/usr/man/man6"
CPDIR="/usr/lib/games/childsplay"
SHAREDIR="/usr/share/childsplay"
BINDIR="/usr/games"
LIBDIR="/usr/lib/games/childsplay/lib"
MODULESDIR="/usr/lib/games/childsplay/lib"
SHARELIBDATADIR="/usr/share/childsplay/lib"
SHAREDATADIR="/usr/share/childsplay/Data"
RCDIR="/usr/share/childsplay/lib/ConfigData"
CHILDSPLAYRC="childsplayrc"
HOME_DIR_NAME=".childsplay"
EOF

#translating words in doinst.sh

#PLUGINS INSTALLATION
cd $startdir/src/childsplay_plugins-0.90
CWD=`pwd`
python $startdir/pkg/usr/lib/games/childsplay/install.py --compile $CWD/lib

echo " Copy libraries"
for DIR in `ls $CWD/lib`
do 
    if [ -d $CWD/lib/$DIR ]
	 then cp -r $CWD/lib/$DIR $startdir/pkg/usr/share/childsplay/lib/
	 else cp  $CWD/lib/$DIR $startdir/pkg/usr/lib/games/childsplay/lib
    fi
done

echo " Copy misc. data files"
cp -r $CWD/Data/*.icon.png $startdir/pkg/usr/share/childsplay/Data/icons/
cp -r $CWD/Data/AlphabetSounds $startdir/pkg/usr/share/childsplay/Data/

echo " Copy assetml files"
cp -r $CWD/assetml/* $startdir/pkg/usr/share/assetml

echo " Copy README's to the childsplay doc directory"
for name in $READMES;do
    cp  $CWD/$name $startdir/pkg/usr/share/doc/childsplay/$name
done

SCORE="Packid,Numbers,Soundmemory,Fallingletters,Findsound,Findsound2,Billiard,Puzzle"
echo -e "\n Trying to add $SCORE to the childsplay score sheet"
echo " Start add-score.py"
python $CWD/add-score.py $startdir/pkg/var/games $SCORE

echo -e "\n Installing MT_users2cvs.py"
echo " Look at the file called README.MT_users2csv for info on how"
echo " to use it. It usage is intended for teachers who want to an"
echo " users resume of the multiplication tables users."
cp $CWD/MT_users2csv.py $startdir/pkg/usr/bin/MT_users2csv.py 
chmod a+x $startdir/pkg/usr/bin/MT_users2csv.py

#change /usr/bin/childsplay to point to correct childsplay.py
cd $startdir/pkg/usr/bin
sed -i "s_/usr/local_/usr_g" childsplay
cd $startdir/pkg/usr/games
sed -i "s_/usr/local_/usr_g" childsplay

#create desktop file
cd $startdir/pkg
cat << "EOF" >$startdir/pkg/usr/share/applications/childsplay.desktop
[Desktop Entry]
Encoding=UTF-8
Name=Childsplay
Exec=childsplay
Terminal=false
Type=Application
Categories=Application;Game;
Icon=childsplay
EOF

} 

create_slackdesc() {
mkdir $startdir/pkg/install
cat <<"EODESC" >$startdir/pkg/install/slack-desc
childsplay: childsplay - educational games suite for children
childsplay: 
childsplay: Childsplay is a suite of educational games for young children,
childsplay: like gcompris, but without the overkill of c/c++ and the gnome
childsplay: environment. Also the use of the SDL libraries makes smooth animation
childsplay: and the playing of sound very easy. Childsplay uses a plugin system
childsplay: for the games.
childsplay: 
childsplay: 
childsplay: 
childsplay: 
EODESC
}

setup_doinst() {
cat <<"EODOINST" >>$startdir/pkg/install/doinst.sh
doinst() {
( cd usr/share/icons/hicolor/48x48/apps ; rm -f childsplay.png )
( cd usr/share/icons/hicolor/48x48/apps ; ln -sf ../../../../childsplay/Data/logo_cp_48x48.png childsplay.png )
( cd usr/share/childsplay/Data ; rm -rf childsplay.score )
( cd usr/share/childsplay/Data ; ln -sf ../../../../../var/games/childsplay.score childsplay.score )
( cd usr/lib/games/childsplay ; python letters-trans.py /usr/share/assetml )


}
doinst
EODOINST
}
copy_docs() {
	for stuff in ${docs[@]}; do
		if [ ! -d "$startdir/pkg/usr/doc/$pkgname-$pkgver" ]; then
			mkdir -p $startdir/pkg/usr/doc/$pkgname-$pkgver
		fi
		find $startdir/src -type f -iname "$stuff" -exec cp -R '{}' $startdir/pkg/usr/doc/$pkgname-$pkgver \;
	done
}
detect_dependencies() {
	echo "Detecting dependencies..."
	depends=$(requiredbuilder -z $startdir/$package.tgz)
	
	depstring=$depends,sdl,SDL_gfx,SDL_sound,libogg,pygame
	unset FIRST
	for deps in $(echo "${depstring}" | sed 's/,/\n/g' | sort -u); do
		if [[ ! "$FIRST" ]]; then
			finaldeps=$deps,
			FIRST='1'
			continue
		fi
		finaldeps=${finaldeps}${deps},
	done
	echo "$finaldeps" | sed -e 's/^,//' -e 's/,$//' > $startdir/$package.dep
}

####End Non Redundant Code############################

#Variables

startdir=$(pwd)
SRC=$startdir/src
PKG=$startdir/pkg

pkgname=childsplay
pkgver=0.90.1
pkgrel=1
zenver=50
arch=i486
package=$pkgname-$pkgver-$arch-$zenver.$pkgrel
source=(http://download.sourceforge.net/childsplay/childsplay-0.90.1.tgz http://download.sourceforge.net/childsplay/childsplay_plugins-0.90.tgz)
docs=(README README.FIRST README-MEMORY)
export CFLAGS="-O2 -march=i486 -mtune=i686"
export CXXFLAGS="-O2 -march=i486 -mtune=i686"

#Execution

check_for_root
clean_old_builds
prepare_directory
extract_source
set_pre_permissions
build
if [ ! "$?" = "0" ]; then
	echo "build() failed."
	exit 2
fi
create_slackdesc
setup_doinst
copy_docs
check_for_menu_compliance
strip_binaries
gzip_man_and_info_pages
set_post_permissions
copy_build_script
create_package
detect_dependencies
echo "Package has been built."
